﻿using C1.WPF.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data.Common;
using System.Linq;
using System.Reflection.Metadata;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CustomMerging_Net6
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Customer> customers = new ObservableCollection<Customer>();
        public MainWindow()
        {
            InitializeComponent();            

            // change appearance a little
            flex.RowBackground = new SolidColorBrush(Colors.White);
            flex.AlternatingRowBackground = flex.RowBackground;
            flex.GridLinesVisibility = GridLinesVisibility.All;
            flex.Rows.DefaultSize = new GridLength(60);
            flex.Columns.DefaultSize = new GridLength(100);

            flex.VerticalAlignment = System.Windows.VerticalAlignment.Center;
            flex.HorizontalAlignment = System.Windows.HorizontalAlignment.Center;
            flex.RowHeaders.Columns[0].HeaderHorizontalAlignment = System.Windows.HorizontalAlignment.Right;

            // activate custom merge manager
            flex.AllowMerging = GridAllowMerging.All;
            flex.MergeManager = new MyMergeManager();

            //// add some unbound rows and columns
            //for (int cols = 0; cols < 6; cols++)
            //{
            //    flex.Columns.Add(new GridColumn() { HorizontalAlignment = HorizontalAlignment.Center });
            //}
            //for (int rows = 0; rows < 6; rows++)
            //{
            //    flex.Rows.Add(new GridRow());
            //}

            // set column headers
            //SetHeaderData(0, "No\tCol1\tCol2\tCol3\tCol4\tCol5");

            // add data
            customers.Add(new Customer(1,"aaaaa",1,"A",1,1));
            customers.Add(new Customer(2, "aaaaa", 2, "A", 2, 1));
            customers.Add(new Customer(3, "bbbbb", 2, "B", 3, 2));
            customers.Add(new Customer(4, "bbbbb", 3, "B", 4, 2));
            customers.Add(new Customer(5, "ccccc", 4, "C", 4, 3));
            customers.Add(new Customer(6, "ddddd", 4, "C", 4, 4));

            flex.ItemsSource = customers;

            Dictionary<int, string> dct = new Dictionary<int, string>();
            foreach (var country in Customer.GetCountries())
            {
                dct[dct.Count] = country.Value;
            }
            flex.Columns["CountryId"].DataMap = new GridDataMap { ItemsSource = dct, SelectedValuePath = "Key", DisplayMemberPath = "Value" };
        }

        private void SetHeaderData(int row, string content)
        {
            var items = content.Split('\t');
            for (int col = 0; col < items.Length; col++)
            {
                flex.ColumnHeaders[row, col] = items[col];
            }
        }

        void SetData(int row, string content)
        {
            var items = content.Split('\t');
            for (int col = 0; col < items.Length; col++)
            {
                flex[row,col] = items[col];
            }
        }
    }
}
