﻿using C1.WPF.Grid;
using Microsoft.VisualBasic;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;

namespace CustomMerging_Net6
{
    public class MyMergeManager : GridMergeManager
    {
        public override GridCellRange GetMergedRange(GridCellType cellType, GridCellRange rg)
        {
            // (not merging row or column headers)
            if (cellType == GridCellType.Cell)
            {
                // For Column 1
                if (rg.Column == 1)
                {
                    for (int i = rg.Row; i < Grid.Rows.Count - 1; i++)
                    {
                        if (GetDataDisplay(i, rg.Column) != GetDataDisplay(i + 1, rg.Column)) break;
                        rg.Row2 = i + 1;

                    }
                    for (int i = rg.Row; i > 0; i--)
                    {
                        if (GetDataDisplay(i, rg.Column) != GetDataDisplay(i - 1, rg.Column)) break;
                        rg.Row = i - 1;
                    }
                }

                //For Column 3 respect to Column 1
                if (rg.Column == 3)
                {
                    for (int i = rg.Row; i < Grid.Rows.Count - 1; i++)
                    {
                        if (GetDataDisplay(i, rg.Column - 2) != GetDataDisplay(i + 1, rg.Column - 2)) break;
                        rg.Row2 = i + 1;

                    }
                    for (int i = rg.Row; i > 0; i--)
                    {
                        if (GetDataDisplay(i, rg.Column - 2) != GetDataDisplay(i - 1, rg.Column - 2)) break;
                        rg.Row = i - 1;
                    }
                }

                //For ComboBox Column 5 respect to column 1
                if (rg.Column == 5)
                {
                    for (int i = rg.Row; i < Grid.Rows.Count - 1; i++)
                    {
                        if (GetDataDisplay(i, rg.Column - 4) != GetDataDisplay(i + 1, rg.Column - 4)) break;
                        rg.Row2 = i + 1;

                    }
                    for (int i = rg.Row; i > 0; i--)
                    {
                        if (GetDataDisplay(i, rg.Column - 4) != GetDataDisplay(i - 1, rg.Column - 4)) break;
                        rg.Row = i - 1;
                    }
                }
            }

            // done
            return rg;
        }
        //public GridCellRange GetMergedRange(GridCellType cellType, CellRange rg)
        //{
           
        //}
        string GetDataDisplay(int r, int c)
        {
            if (Grid[r, c] != null)
                return Grid[r, c].ToString();
            return "";
        }
    }
}
